import { Bytes } from '@cmdcode/buff-utils';
import * as Noble from '@cmdcode/secp256k1';
type FieldNum = string | number | bigint | Uint8Array | Field;
type PointNum = string | number | bigint | Uint8Array | Point;
export declare class Field extends Uint8Array {
    static N: bigint;
    static mod(n: bigint, m?: bigint): bigint;
    static isField: (x: any) => boolean;
    static normalize(num: FieldNum): Uint8Array;
    static validate(num: bigint): boolean;
    constructor(num: FieldNum);
    get num(): bigint;
    get point(): Point;
    get hasOddY(): boolean;
    get negated(): Field;
    gt(num: FieldNum): boolean;
    lt(num: FieldNum): boolean;
    eq(num: FieldNum): boolean;
    ne(num: FieldNum): boolean;
    add(num: FieldNum): Field;
    sub(num: FieldNum): Field;
    mul(num: FieldNum): Field;
    pow(num: FieldNum, n?: bigint): Field;
    div(num: FieldNum): Field;
    negate(): Field;
}
export declare class Point {
    static N: bigint;
    static normalize(num: PointNum): bigint;
    static fromNum(num: PointNum): Point;
    static fromXOnly(x: PointNum): Point;
    static from(point: Point | Noble.Point): Point;
    private readonly __p;
    private readonly __x;
    private readonly __y;
    constructor(x: bigint, y: bigint);
    get p(): Noble.Point;
    get hasOddY(): boolean;
    get rawX(): Uint8Array;
    get rawXR(): Uint8Array;
    get rawY(): Uint8Array;
    get x(): bigint;
    get y(): bigint;
    eq(x: PointNum): boolean;
    add(x: PointNum): Point;
    sub(x: PointNum): Point;
    mul(x: PointNum): Point;
    negate(): Point;
}
export declare class KeyPair {
    private readonly _secret;
    static generate(): KeyPair;
    constructor(secret: Bytes);
    get field(): Field;
    get point(): Point;
    get privateKey(): Uint8Array;
    get privateHex(): string;
    get publicKey(): Uint8Array;
    get publicHex(): string;
    get xOnlyPub(): Uint8Array;
    get prvkey(): string;
    get pubkey(): string;
}
export {};
//# sourceMappingURL=ecc.d.ts.map