import { Bytes } from '@cmdcode/buff-utils';
import { KeyPair } from './ecc.js';
export type SignatureTypes = 'ecdsa' | 'schnorr';
export declare class Signer extends KeyPair {
    readonly type: SignatureTypes;
    static generate(): Signer;
    constructor(secret: Bytes, type?: SignatureTypes);
    sign(message: Bytes): Promise<Uint8Array>;
    verify(message: Bytes, signature: Bytes): Promise<boolean>;
    static sign(message: Bytes, secret: Bytes, type?: SignatureTypes): Promise<Uint8Array>;
    static verify(message: Bytes, pubKey: Bytes, signature: Bytes, type?: SignatureTypes): Promise<boolean>;
}
//# sourceMappingURL=signer.d.ts.map